/*
 *  Common Services Library - Framework plug-in.
 *  (C) Copyright Fundi Software 2011, 2016.  Fundi Confidential.
 *  All rights reserved.  Use, duplication or disclosure restricted. 
 */

package com.fundi.framework.common.change;

import java.util.Map;

public interface IChangeable {

	//Eye catchers.
	public static final String EC_COPYRIGHT = "(C) Copyright 2011, 2016 Fundi Software.  Fundi Confidential."; //$NON-NLS-1$
	public static final String EC_APAR = "3.1.1.00_00014"; //$NON-NLS-1$
	public static final String EC_FMID = "H30SA10"; //$NON-NLS-1$
	public static final String EC_PID = "5655-CSL"; //$NON-NLS-1$
	
	public ChangeListScope 	getChangeListScope();
	
	public void 			setChangeListScope(ChangeListScope cls);
	
	public Object 			getSource();
	
	public boolean 			isRecognisedKey(Object key);
	
	public Object 			getInitialValue(Object key);	//in the case of a ListRow this will be a String
	
	public Object 			getFinalValue(Object key);
	
	public Object			getInitialObject(Object key);	//In the case of a ListRow this will be a ListField
	
	public Object			getFinalObject(Object key);
	
	public Map<?, ?>		getChangedObjects();			//alias for applyChanges() - a List of ListField only including those that have changes registered against them.
	
}
